// Copyright (c) 2024-2026 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// term-constructor-registry.go
package scan

import "git.portale-stac.it/go-pkg/expr/sym"

const initialRegistryCapacity = 10

type termContructor func(tk *Token) *Term

var constructorRegistry map[sym.Symbol]termContructor = nil

func RegisterTermConstructor(symmbol sym.Symbol, constructor termContructor) {
	if constructorRegistry == nil {
		constructorRegistry = make(map[sym.Symbol]termContructor, initialRegistryCapacity)
	}
	constructorRegistry[symmbol] = constructor
}

func NewTerm(tk *Token) (inst *Term) {
	if constructorRegistry != nil {
		if construct, exists := constructorRegistry[tk.Sym]; exists {
			inst = construct(tk)
		}
	}
	return
}
